package org.t2framework.lucy.tx.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.t2framework.commons.annotation.Composite;
import org.t2framework.commons.annotation.Lookup;
import org.t2framework.commons.annotation.core.Aspect;
import org.t2framework.lucy.tx.interceptor.RequiresNewInterceptor;

@Retention(RetentionPolicy.RUNTIME)
@Target( { ElementType.TYPE })
@Composite
@Aspect(interceptBy = RequiresNewInterceptor.class)
public @interface RequiresNewTx {

	@Lookup(value = Aspect.class, alias = "pointcut")
	String value() default ".*";
}
