package org.t2framework.lucy.tx.interceptor;

import java.lang.reflect.Method;

import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.aop.spi.Invocation;
import org.t2framework.lucy.annotation.core.Inject;
import org.t2framework.lucy.tx.TransactionProcesser;
import org.t2framework.lucy.tx.Worker;

public abstract class AbstractTxInterceptor implements Interceptor {

	protected TransactionProcesser processer;

	protected WorkerAdapterFactory factory;

	public TransactionProcesser getProcesser() {
		return processer;
	}

	@Inject
	public void setProcesser(TransactionProcesser processer) {
		this.processer = processer;
	}

	public WorkerAdapterFactory getFactory() {
		return factory;
	}

	@Inject
	public void setFactory(WorkerAdapterFactory factory) {
		this.factory = factory;
	}

	@Override
	public Object intercept(Invocation<Method> invocation) throws Throwable {
		try {
			return process(getFactory().adapt(invocation));
		} catch (Throwable t) {
			throw t;
		}
	}

	protected abstract Object process(Worker<Object> worker) throws Throwable;
}
