package org.t2framework.lucy.tx.interceptor;

import java.lang.reflect.Method;

import org.t2framework.commons.aop.spi.Invocation;
import org.t2framework.lucy.tx.TransactionWrapper;
import org.t2framework.lucy.tx.Worker;

public class InvocationWorker implements Worker<Object> {

	protected Invocation<Method> invocation;

	public InvocationWorker(Invocation<Method> invocation) {
		this.invocation = invocation;
	}

	@Override
	public Object work(TransactionWrapper helper) throws Throwable {
		try {
			return this.invocation.proceed();
		} catch (Throwable t) {
			helper.setRollbackOnly();
			throw t;
		}
	}

}
